/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 **********************************************************************/

#ifdef USE_UI_GTK
#ifndef GTK_PARTY_SETTINGS_PLAYERS_HEADER
#define GTK_PARTY_SETTINGS_PLAYERS_HEADER

#include "party_settings.h"

#include "widget.h"

class Player;

namespace GTK_DOKO {
#include <gtk/gtkwidget.h>

  class PartySettings::Players {
    public:
      class Player;
      class AiConfigs;

    public:
      // constructor
      Players(PartySettings* const party_settings);
      // destructor
      ~Players();


      // update the sensitivity
      void sensitivity_update();

      // create a backup
      void backup();
      // destroy the backup
      void backup_destroy();

      // reset the settings
      void reset(); 

      // the variables
      class GTK_GUI& gui(); // the gui
      PartySettings& party_settings(); // the party settings
      GtkWidget* widget(); // the widget (container)

      // the player
      Player& player(unsigned const playerno);
      // the aiconfigs of all players
      AiConfigs& aiconfigs();
      // the aiconfig
      class AiConfig& aiconfig(unsigned const playerno);

    private:
      // event that the page has changed
      static void switch_page_event(GtkNotebook*, GtkNotebookPage*,
				    gint page_num, gpointer player);
    public:
      // the current player has changed
      void switch_page(unsigned const page_num);


      // update all
      void update();

      // update the name of the player
      void name_update(::Player const& player);
      // update the player
      void player_update(::Player const& player);

      // update the language
      void language_update();
    private:
      PartySettings* const party_settings_; // the party settings

      AiConfigs* aiconfigs_; // the configuration
      vector<Player*> player_; // the single players

      GtkWidget* notebook; // the notebook with the players
      vector<GtkWidget*> player_label; // the labels of the players

    private: // not to be used
      Players();
      Players(Players const&);
      Players& operator=(Players const&);
  }; // class PartySettings::Players


} // namespace GTK_DOKO

#endif // #ifndef GTK_PARTY_SETTINGS_PLAYERS_HEADER
#endif // #ifdef USE_UI_GTK
